//+------------------------------------------------------------------+
//|                                              FileWriteSample.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""

extern int ATRperiod=14;
extern double stoplevel=4.5;
extern double lots=0.1;
extern int Magic=216326;
extern string FileName="writesample";
extern string FileType="txt";

int bar;
int writebar;
double HighAB;
string filename;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
      filename=FileName + "." + FileType;
      int handle;
      handle=FileOpen(filename,FILE_WRITE,"\t");
      if(handle>0)
      {
         FileWrite(handle ,"Month","Day","Hour","Balance", "Equity", "PosDD","DD");
         FileClose(handle);
      }
      
      MathSrand(TimeLocal());
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //c̍ōzXV
   if(AccountBalance()>HighAB) HighAB=AccountBalance();

   //ARTgXgbvp̐ľvZ
   double atr3=NormalizeDouble(iATR(NULL,0,ATRperiod,0)*stoplevel,MarketInfo(Symbol(),MODE_DIGITS));
   
   //|WV̊mF
   int pos=-1;
   for(int i=OrdersTotal()-1;i>=0;i--)
   {
      OrderSelect(i,SELECT_BY_POS);
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic) pos=i;
   }
   
   //|WV̎
   if(pos<0)
   {
      int sign = MathRand() % 2;  //0 or 1   
      if(sign==0)
         OrderSend(Symbol(), OP_BUY, lots, Ask, 3,  Ask-atr3, 0, "", Magic, 0, Blue);
      if(sign==1)
         OrderSend(Symbol(), OP_SELL, lots, Bid, 3,  Bid+atr3, 0, "", Magic, 0, Red);
   }
   //|WVL̎
   else
   {
      //gCO
      for(int cnt = OrdersTotal()-1 ; cnt >=0 ; cnt--)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if(OrderSymbol() == Symbol() && OrderMagicNumber() == Magic) 
         {	
            if(OrderType() == OP_SELL) 
	  	  	   {    
               if(OrderStopLoss() > Ask + atr3 || OrderStopLoss()==0)
               {			
                  OrderModify(OrderTicket(), OrderOpenPrice(), Ask + atr3,
                                 OrderTakeProfit(), 0, Purple);
	  				}
	  			}
	  	      if(OrderType() == OP_BUY)
	  		   {
			      if(OrderStopLoss() < Bid - atr3) 
					{					   
                  OrderModify(OrderTicket(), OrderOpenPrice(),Bid - atr3, 
                              OrderTakeProfit(), 0, Yellow);
					}
            } 
         }
      }//for̃JbR

      //t@C
      if(iBars(NULL,240)!=writebar)
      {
         int month=TimeMonth(TimeCurrent());
         int day=TimeDay(TimeCurrent());
         int hour=TimeHour(TimeCurrent());
         double AB=AccountBalance() ;
         double AE=AccountEquity() ;
         double posDD=(1-AE/AB)*100;
         if(posDD<=0) string posDDstr="-";
         else posDDstr=DoubleToStr(posDD,2)+"%";
         double HighDD=(1-AE/HighAB)*100;
         if(HighDD<=0) string HighDDstr="-";
         else HighDDstr=DoubleToStr(HighDD,2)+"%";
         
         
         
         int handle;
         handle=FileOpen(filename,FILE_READ|FILE_WRITE,"\t");
         if(handle>0)
         {
            FileSeek(handle, 0, SEEK_END);
            FileWrite(handle ,month,day,hour,DoubleToStr(AB,2), DoubleToStr(AE,2), posDDstr,HighDDstr);
            FileClose(handle);
            writebar=iBars(NULL,240);
         }
      }
   }//|WVL̎̃JbR
//----
   return(0);
  }
//+------------------------------------------------------------------+